<?

class CNPartObject extends CNObject {
 
 var $d_partId;
 
 function CNPartObject( $part_id = 0) {
 parent::CNObject();
 $this->setID($part_id);
 }

 function _setID($id) {
 $this->d_partId = $id;
 }

 function getID() {
 return $this->d_partId;
 }

 function setMother (&$mothertag) {
 $this->setObjectRef( "mother", $mothertag );
 }

 function& getMother()
 {
 return $this->getObjectRef( "mother" );
 }

 function getTType () {
 global $T_PART;
 return $T_PART;
 }
 
 function &getPartType () {
 $partType = &$this->getObjectRef( "parttype" );
 if ($partType === NULL ) {
 $partType = CNPartTypeFactory::getPartType($this->getFieldValue("type_id"));
 $this->setObjectRef( "parttype", $partType );
 }
 return $partType;
 }

 function cleanup() {
 $type = &$this->getPartType();
 $type->cleanupParts($this->getId());
 }
 
 function setValue( &$value, $setRec=true )
 {
 $this->setObjectRef( "partvalue", $value );
 if ( $setRec )
 $value->setPartObject( $this, false );
 }
 
 function &getValue () {
 $value = &$this->getObjectRef( "partvalue" );
 if ($value === NULL) {
 
 $mother = &$this->getMother();
 if ($mother === NULL) return NULL;
 $sql = 'SELECT id, value_text, value_ref, info FROM value WHERE part_id = '.
 sqlf_tl_num($this->getID()).' AND '.sqlf_name($mother->getTagType()).'tag_id = '.sqlf_tl_num($mother->getID());
 $rs = query($sql);
 $v = $rs['arr'][0];
 $value = new CNValue ( $v['id'] );
 $value->setPartObject ( $this );
 $this->setObjectRef( "partvalue", $value );
 }
 return $value;
 }

 function getValueFields() {
 return array("construct_id"=>false, "type_id"=>false, "name_id"=>false, "required"=>"checkbox", "editable"=>"checkbox", 
 "partoption_id"=>false, "partorder"=>"int", "keyword"=>"text", "hidden"=>"checkbox", "ml_id"=>false);
 }

 function _getNodeTable() { return "part"; }

 function getObjectKey()
 {
 $keyword = $this->getFieldValue("keyword");
 if ( $keyword )
 {
 return $keyword;
 } 
 return $this->getID();
 }
 
 function getName() 
 {
 return $this->_idToDicUser( $this->getFieldValue("name_id") );
 }

 function isRequired()
 {
 return $this->getFieldValue("required")?TRUE:FALSE;
 }
 
 function isEditable()
 {
 return $this->getFieldValue("editable") != 0;
 }

 function isInlineEditable()
 {
 return $this->getFieldValue("editable") == 2;
 }
 
 function &getProperty($key) {
 switch ($key) {
 case "id": 
 $class = new IntObject($this->getID());
 break;
 case "construct_id":
 $class = new IntObject($this->getFieldValue("construct_id"));
 break;
 case "type_id":
 $class = new IntObject($this->getFieldValue("type_id"));
 break;
 case "name_id":
 $class = new IntObject($this->getFieldValue("name_id"));
 break;
 case "name":
 $class = new StringObject($this->getName());
 break;
 case "required":
 $class = new StringObject($this->getFieldValue("required"));
 break;
 case "editable":
 $class = new IntObject($this->getFieldValue("editable"));
 break;
 case "partoption_id":
 $class = new IntObject($this->getFieldValue("partoption_id"));
 break;
 case "partorder":
 $class = new IntObject($this->getFieldValue("partorder"));
 break;
 case "keyword":
 $class = new StringObject($this->getFieldValue("keyword"));
 break;
 case "hidden":
 $class = new IntObject($this->getFieldValue("hidden"));
 break;
 case "ml_id":
 $class = new IntObject($this->getFieldValue("ml_id"));
 break;
 case "value_id":
 $this->_initValue();
 $class = new StringObject($this->d_valueId);
 break;
 case "value_text":
 $this->_initValue();
 $class = new StringObject($this->d_valueText);
 break;
 case "value_ref":
 $this->_initValue();
 $class = new StringObject($this->d_valueRef);
 break;
 case "value_info":
 $this->_initValue();
 $class = new StringObject($this->d_valueInfo);
 break;
 default: 
 $class = &parent::getProperty($key);
 }
 return $class;
 }

 function getXML($level = 0, $prefix = '') {
 $xml = $prefix.'<part>'."\n";
 $xml .= $prefix.'  <id>'. $this->getID().'</id>'."\n";
 $xml .= $prefix.'  <keyword>'. $this->getFieldValue("keyword").'</keyword>'."\n";
 $xml .= $prefix.'</part>'."\n";
 return $xml;
 }

 function getPartOrder() {
 return $this->getFieldValue("partorder");
 }

 function getPartTypeID() {
 return $this->getFieldValue("type_id");
 }

 function getMlID() {
 return $this->getFieldValue("ml_id");
 }

 function getKeyname() {
 return $this->getFieldValue("keyword");
 }

 function isVisible() {
 return $this->getFieldValue("hidden")?false:true;
 }

 function getConstructID() {
 return $this->getFieldValue("construct_id");
 }
 
 function& getFormObject () {
 return new CNPartFormObject( $this ); 
 }

 function& getFormComponent() {
 $partType = &$this->getPartType();
 $value = &$this->getValue();
 return $partType->getEditFormComponent($value);
 }
 
 function storeFormComponent(&$component) {
 $partType = &$this->getPartType();
 $value = &$this->getValue();
 $partType->storeFormToValue($component, $value);
 }
 
 function save() {
 if ( parent::save() ) {
 $value =& $this->getValue();
 $value->save();
 }
 }
 
}

class CNValue extends CNObject {

 var $d_valId;

 function CNValue( $id = 0 ) {
 parent::CNObject();
 $this->setID($id);
 }

 function _setID($id) {
 $this->d_valId = $id;
 }

 function getID() {
 return $this->d_valId;
 }

 function getValueFields() {
 return array("part_id"=>false, "info"=>false, "static"=>false, "templatetag_id"=>false, "contenttag_id"=>false, 
 "objtag_id"=>false, "value_text"=>false, "value_ref"=>false);
 }

 function _getNodeTable() { return "value"; }
 
 function getText() {
 return $this->getFieldValue("value_text");
 }

 function setText( $value_text ) {
 return $this->setFieldValue("value_text", $value_text);
 }

 function getInfo() {
 return $this->getFieldValue("info");
 }

 function setInfo( $info) {
 return $this->setFieldValue("info", $info);
 }

 function getReference() {
 return $this->getFieldValue("value_ref");
 }

 function setReference( $value_ref ) {
 return $this->setFieldValue("value_ref", $value_ref);
 }

 function getPartID() {
 return $this->getFieldValue("part_id");
 }
 
 function setPartID( $id ) {
 $this->setFieldValue( "part_id", $id );
 }

 function setPartObject ( &$partObject, $setRec=true ) {
 $this->setObjectRef( "partObj", $partObject );
 if ( $setRec )
 $partObject->setValue( $this, false );
 $this->setFieldValue( "part_id", $partObject->getID() );
 $tagObject =& $partObject->getMother();
 $this->setFieldValue( $tagObject->getTagType()."tag_id", $tagObject->getID() );
 }

 function &getPartObject () {
 $obj =& $this->getObjectRef( "partObj" );
 if ( $obj === NULL ) {
 
 $this->setObjectRef( "partObj", ($obj=new CNPartObject ( $this->getPartID() ) ) );
 }
 return $obj;
 }
 
}

class CNPartFormObject extends NodeFormObject {

 function CNPartFormObject ( &$part ) {
 parent::NodeFormObject( $part );
 }

 function isNew() {
 return false;
 $nodeObject = &$this->getEditObject();
 $value = &$nodeObject->getValue();
 return $value->isNew();
 }
 
 function getValueFields() {
 return array('part'=>false);
 }

 function getStoredFieldValue($field) {
 return $this->nodeObject->getStoredFieldValue($field);
 }
 
 function &getFieldValue($field) {
 return $this->nodeObject->getFieldValue($field);
 }
 
 function setFieldValue($field, $value, $initOnly = false) {
 return $this->nodeObject->setFieldValue($field, $value, $initOnly);
 }
 
 
 
 






 function getListHeaders() { return array(); }
 
 


 function getFieldDescriptions() { return array(); }

 function getFieldLabels() {
 $nodeObject = &$this->getEditObject();
 $name = $nodeObject->getProperty('name');
 return array('part'=>$name->toString()); 
 }
 
 




 function isEditableField($field) { 
 return true;
 $nodeObject = &$this->getEditObject();
 $editable = $nodeObject->getProperty('editable');
 return $editable->toString(); 
 }

 function isOptionalField($field) { 
 $nodeObject = &$this->getEditObject();
 $editable = $nodeObject->getProperty('required');
 return !$editable->toString(); 
 }

 




 function &getFormComponent($field) {
 $nodeObject = &$this->getEditObject();
 return $nodeObject->getFormComponent();
 }

 


 function storeFormComponent($field, &$component) { 
 $nodeObject = &$this->getEditObject();
 $nodeObject->storeFormComponent( $component );
 }
}

?>
