<?





















$LIB_PATH = $XNL_PATH . "/gentics/lib/";

include_once ( $LIB_PATH . "base/nodeobject.class.php" );
include_once ( $LIB_PATH . "base/events.php" );
include_once ( $LIB_PATH . "xml/xmlparser.class.php" );
include_once ( $LIB_PATH . "xml/xml_parser.class.php" );

class XnlInfo
{
 var $d_errors = array();
 var $d_infos = array();
 var $d_warnings = array();
 var $d_dependencies = array();
 var $d_params = array();

 function XnlInfo( $params )
 {
 $this->d_params = $params; 
 }
 
 
 function info( $key, $text, $detail="" )
 {
 $this->d_infos[] = array("key"=>$key, "text"=>$text, "detail"=>$detail ); 
 }
 
 function warning( $key, $text, $detail="" )
 {
 $this->d_warnings[] = array("key"=>$key, "text"=>$text, "detail"=>$detail );
 }
 
 function error( $key, $text, $detail="" )
 {
 $this->d_errors[] = array("key"=>$key, "text"=>$text, "detail"=>$detail);
 }
 
 
 
 function addDependency( $type, $id, $eventType = EVENT_ALL, $eventIgnore = 0 )
 {
 $this->d_dependencies[] = array( "type"=>$type, "id"=>$id, "event"=>$eventType, "eventIgnore"=>$eventIgnore );
 }
 
 
 
 





 function getParam( $name )
 {
 if ( isset( $this->d_params[$name] ) )
 return $this->d_params[$name];
 return NULL;
 }
 
 



















 function getXmlParam( $param, $childKey, $indexKey, $values=false )
 {
 $xml = "<$param>".$this->getParam($param)."</$param>";
 
 $parser = new XMLParser();
 $parser->loadXML( $xml );
 $xmlstruct = $parser->getStruct();
 if ( !is_array($xmlstruct) )
 {
 $this->error( "xml-param", "$param: XML-Error(".$parser->getErrorCode().") on Line: ".
 $parser->getErrorLine()." - Col: ".$parser->getErrorCol()." = ".$parser->getErrorMessage(), 
 $xml );
 return false;
 }
 
 $xmlArr = array();
 $param = strtoupper($param);
 $childKey = strtoupper($childKey);
 $indexKey = strtoupper($indexKey);
 
 if ( is_array( $xmlstruct[$param]["childs"][$childKey] ) ) {
 foreach ( $xmlstruct[$param]["childs"][$childKey] as $result )
 {
 if ( is_array($values) )
 {
 foreach ( $values as $value )
 {
 $xmlArr[$result["attributes"][$indexKey]][$value] = 
 $result["childs"][strtoupper($value)][0]["value"];
 }
 }
 else
 $xmlArr[$result["attributes"][$indexKey]] = $result["value"];
 }
 }
 return $xmlArr; 
 }
 
 function getInfos()
 {
 return $this->d_infos;
 }
 
 function getWarnings()
 {
 return $this->d_warnings;
 }
 
 function getErrors()
 {
 return $this->d_errors;
 }
 
 
 function getDependencies()
 {
 return $this->d_dependencies;
 }
 
 
 
 function hasWarnings()
 {
 return count($this->d_warnings) > 0;
 }
 
 function hasFailed()
 {
 return count($this->d_errors) > 0;
 }

 



 function isDynamicCMSRequest()
 {
 $p = $this->getParam( "gti_is_dynamic" );
 if ( $p ) return true;
 return false;
 }

 function getCMSSessionID()
 {
 return $this->getParam("gti_session_id" );
 }

 


 function getCMSPageUrl($page_id) {
 global $STAG_PREFIX;
 if (!$this->isDynamicCMSRequest()) return false;
 return "$STAG_PREFIX?sid=".$this->getCMSSessionID()."&do=14001&live=".((int) $page_id);
 }
}










function makeCDATAcompatible( $value )
{
 return str_replace( "]]>", "]] >" ,$value );
}

function buildDependencyXML( $info, $prefix )
{
 $deps = $info->getDependencies();
 $xml = "";
 $xml .= "$prefix<dependencies>\n";
 foreach ( $deps as $dep )
 {
 $xml .= "$prefix\t<dependency type=\"".$dep["type"]."\">\n";
 $xml .= "$prefix\t\t<id>".$dep["id"]."</id>\n";
 $xml .= "$prefix\t\t<event>".$dep["event"]."</event>\n";
 $xml .= "$prefix\t\t<ignore>".$dep["eventIgnore"]."</ignore>\n";
 $xml .= "$prefix\t</dependency>\n";
 }
 $xml .= "$prefix</dependencies>\n";
 return $xml;
}

function translateInfoArrayToXML( $arr, $type, $prefix )
{
 $ret = "";
 foreach ( $arr as $a )
 {
 $ret .= "$prefix<info type=\"$type\">\n";
 $ret .= "$prefix\t<key><![CDATA[".htmlentities($a["key"])."]]></key>\n";
 $ret .= "$prefix\t<text><![CDATA[".htmlentities($a["text"])."]]></text>\n";
 $ret .= "$prefix\t<detail><![CDATA[".$a["detail"]."]]></detail>\n";
 $ret .= "$prefix</info>\n";
 }
 return $ret;
}

function buildInfoXML( &$info, $prefix )
{
 
 $xml = buildDependencyXML( $info, $prefix );
 $xml .= "$prefix<infos>\n";
 $xml .= translateInfoArrayToXML( $info->getInfos(), "info", $prefix."\t" );
 $xml .= translateInfoArrayToXML( $info->getWarnings(), "warning", $prefix."\t" );
 $xml .= translateInfoArrayToXML( $info->getErrors(), "error", $prefix."\t" );
 $xml .= "$prefix</infos>\n";
 return $xml;
}

function buildReturnXML( $value, &$info )
{
 $xml = "<?xml version='1.0' encoding=\"iso-8859-1\" ?>\n";
 $xml .= "<result>\n";
 $xml .= buildInfoXML( $info, "\t" );
 $xml .= "\t<returnvalue>";
 $xml .= "<![CDATA[";
 $xml .= makeCDATAcompatible(urlencode( $value ));
 $xml .= "]]>";
 $xml .= "</returnvalue>\n";
 $xml .= "</result>\n";
 return $xml;
}


function getPackageInfo($package) {
 global $XNL_PATH;

 $dir = $XNL_PATH."/".str_replace(".","/",$package);
 $d = @dir($dir);
 $packXML = "";

 if ( is_object( $d ) ) {
 while (false !== ($entry = $d->read())) {
 
 if (!ereg("\.xml$",$entry)) continue;
 
 
 $xml = implode("",file($dir."/".$entry));
 if (!eregi("<packages *>(.+)</packages *>", $xml, $regs)) continue;
 $packages = $regs[1];
 $packXML .= $packages;
 }
 }
 return $packXML;
}

function buildPackageXML($package) {

 if (!$package) halt(1,"No package to load config for.");

 
 
 global $XNL_PATH;
 $dir = $XNL_PATH."/".str_replace(".","/",$package);
 return implode("",file($dir."/config.xml"));

}


$method = $HTTP_GET_VARS["method"];
$config = $HTTP_GET_VARS["config"];
$params = $HTTP_POST_VARS;



function halt($id, $err) {
 echo "ERROR: $id; MSG: $err\n";
 die();
}



header("Content-Type: text/xml");

if (!$XNL_PATH) {
 halt(1, "XNL_PATH is not set!");
}

if ($soap) {
 $xml = implode("",file("$XNL_PATH/config.xml"));
 
 $parser = new xml_parser;
 $test = xml_parse($xml,''); 
 
} elseif ($config == "all") {
 
 $xml = implode("",file("$XNL_PATH/config.xml"));
 
 
} else if ($config) {
 
 $xml = buildPackageXML($config);
} else {

 
 $split = explode(".",$method);
 $count = count($split);
 if ($count < 2) {
 halt(1, "Invalid method request ($method).");
 }

 
 $filename = "$XNL_PATH/";
 for ($i = 0; $i < $count - 2; $i++) {
 $filename .= $split[$i]."/";
 }
 $filename .= $split[$count - 2].".xnl_func.php";
 $function = "xnl_func_".$split[$count - 1];

 
 $code = $params["code"];
 unset($params["code"]);

 
 if (!$filename || !$function) {
 halt(1, "Parameter filename ($filename) or function ($function) not set.");
 }

 if (!file_exists($filename)) {
 halt(1, "Include ($filename) does not exist.");
 }

 include($filename);
 if (!function_exists($function)) {
 halt(1, "Function ($function) does not exist in include ($filename).");
 }

 
 $info = new XnlInfo( $params );
 $ret = $function($code, $info);

 $xml = buildReturnXML( $ret, $info );
}

echo $xml;

?>
