<?php






























require_once(INCLUDE_PATH."/common.php");

class DB_fbsql extends DB_common
{
 

 var $connection;
 var $phptype, $dbsyntax;
 var $prepare_tokens = array();
 var $prepare_types = array();
 var $num_rows = array();
 var $fetchmode = DB_FETCHMODE_ORDERED; 

 
 

 





 function DB_fbsql()
 {
 $this->DB_common();
 $this->phptype = 'fbsql';
 $this->dbsyntax = 'fbsql';
 $this->features = array(
 'prepare' => false,
 'pconnect' => true,
 'transactions' => true,
 'limit' => 'emulate'
 );
 $this->errorcode_map = array(
 1004 => DB_ERROR_CANNOT_CREATE,
 1005 => DB_ERROR_CANNOT_CREATE,
 1006 => DB_ERROR_CANNOT_CREATE,
 1007 => DB_ERROR_ALREADY_EXISTS,
 1008 => DB_ERROR_CANNOT_DROP,
 1046 => DB_ERROR_NODBSELECTED,
 1050 => DB_ERROR_ALREADY_EXISTS,
 1051 => DB_ERROR_NOSUCHTABLE,
 1054 => DB_ERROR_NOSUCHFIELD,
 1062 => DB_ERROR_ALREADY_EXISTS,
 1064 => DB_ERROR_SYNTAX,
 1100 => DB_ERROR_NOT_LOCKED,
 1136 => DB_ERROR_VALUE_COUNT_ON_ROW,
 1146 => DB_ERROR_NOSUCHTABLE,
 );
 }

 

 

 









 function connect($dsninfo, $persistent = false)
 {
 if (!DB::assertExtension('fbsql'))
 return $this->raiseError(DB_ERROR_EXTENSION_NOT_FOUND);

 $this->dsn = $dsninfo;
 $dbhost = $dsninfo['hostspec'] ? $dsninfo['hostspec'] : 'localhost';
 $user = $dsninfo['username'];
 $pw = $dsninfo['password'];

 $connect_function = $persistent ? 'fbsql_pconnect' : 'fbsql_connect';

 ini_set('track_errors', true);
 if ($dbhost && $user && $pw) {
 $conn = @$connect_function($dbhost, $user, $pw);
 } elseif ($dbhost && $user) {
 $conn = @$connect_function($dbhost, $user);
 } elseif ($dbhost) {
 $conn = @$connect_function($dbhost);
 } else {
 $conn = false;
 }
 ini_restore("track_errors");
 if (empty($conn)) {
 if (empty($php_errormsg)) {
 return $this->raiseError(DB_ERROR_CONNECT_FAILED);
 } else {
 return $this->raiseError(DB_ERROR_CONNECT_FAILED, null, null,
 null, $php_errormsg);
 }
 }

 if ($dsninfo['database']) {
 if (!fbsql_select_db($dsninfo['database'], $conn)) {
 return $this->fbsqlRaiseError();
 }
 }

 $this->connection = $conn;
 return DB_OK;
 }

 
 

 






 function disconnect()
 {
 $ret = fbsql_close($this->connection);
 $this->connection = null;
 return $ret;
 }

 
 

 











 function simpleQuery($query)
 {
 $this->last_query = $query;
 $query = $this->modifyQuery($query);
 $result = @fbsql_query("$query;", $this->connection);
 if (!$result) {
 return $this->fbsqlRaiseError();
 }
 
 
 if (DB::isManip($query)) {
 return DB_OK;
 }
 $numrows = $this->numrows($result);
 if (is_object($numrows)) {
 return $numrows;
 }
 $this->num_rows[$result] = $numrows;
 return $result;
 }

 
 

 








 function nextResult($result)
 {
 return @fbsql_next_result($result);
 }

 
 

 







 function fetchRow($result, $fetchmode = DB_FETCHMODE_DEFAULT, $rownum=null)
 {
 if ($fetchmode == DB_FETCHMODE_DEFAULT) {
 $fetchmode = $this->fetchmode;
 }
 $res = $this->fetchInto ($result, $arr, $fetchmode, $rownum);
 if ($res !== DB_OK) {
 return $res;
 }
 return $arr;
 }

 
 

 










 function fetchInto($result, &$arr, $fetchmode, $rownum=null)
 {
 if ($rownum !== null) {
 if (!@fbsql_data_seek($result, $rownum)) {
 return null;
 }
 }
 if ($fetchmode & DB_FETCHMODE_ASSOC) {
 $arr = @fbsql_fetch_array($result, FBSQL_ASSOC);
 } else {
 $arr = @fbsql_fetch_row($result);
 }
 if (!$arr) {
 $errno = @fbsql_errno($this->connection);
 if (!$errno) {
 return NULL;
 }
 return $this->fbsqlRaiseError($errno);
 }
 return DB_OK;
 }

 
 

 








 function freeResult($result)
 {
 if (is_resource($result)) {
 return fbsql_free_result($result);
 }

 if (!isset($this->prepare_tokens[(int)$result])) {
 return false;
 }

 unset($this->prepare_tokens[(int)$result]);
 unset($this->prepare_types[(int)$result]);

 return true;
 }

 
 

 function autoCommit($onoff=false)
 {
 if ($onoff) {
 $this->query("SET COMMIT TRUE");
 } else {
 $this->query("SET COMMIT FALSE");
 }
 }

 
 

 function commit()
 {
 fbsql_commit();
 }

 
 

 function rollback()
 {
 fbsql_rollback();
 }

 
 

 








 function numCols($result)
 {
 $cols = @fbsql_num_fields($result);

 if (!$cols) {
 return $this->fbsqlRaiseError();
 }

 return $cols;
 }

 
 

 








 function numRows($result)
 {
 $rows = @fbsql_num_rows($result);
 if ($rows === null) {
 return $this->fbsqlRaiseError();
 }
 return $rows;
 }

 
 

 






 function affectedRows()
 {
 if (DB::isManip($this->last_query)) {
 $result = @fbsql_affected_rows($this->connection);
 } else {
 $result = 0;
 }
 return $result;
 }

 
 

 








 function errorNative()
 {
 return fbsql_errno($this->connection);
 }

 
 

 












 function nextId($seq_name, $ondemand = true)
 {
 $sqn = preg_replace('/[^a-z0-9_]/i', '_', $seq_name);
 $repeat = 0;
 do {
 $seqname = sprintf($this->getOption("seqname_format"), $sqn);
 $result = $this->query("INSERT INTO ${seqname} VALUES(NULL)");
 if ($ondemand && DB::isError($result) &&
 $result->getCode() == DB_ERROR_NOSUCHTABLE) {
 $repeat = 1;
 $result = $this->createSequence($seq_name);
 if (DB::isError($result)) {
 return $result;
 }
 } else {
 $repeat = 0;
 }
 } while ($repeat);
 if (DB::isError($result)) {
 return $result;
 }
 return fbsql_insert_id($this->connection);
 }

 
 

 function createSequence($seq_name)
 {
 $sqn = preg_replace('/[^a-z0-9_]/i', '_', $seq_name);
 $seqname = sprintf($this->getOption("seqname_format"), $sqn);
 return $this->query("CREATE TABLE ${seqname} ".
 '(id INTEGER UNSIGNED AUTO_INCREMENT NOT NULL,'.
 ' PRIMARY KEY(id))');
 }

 
 

 function dropSequence($seq_name)
 {
 $sqn = preg_replace('/[^a-z0-9_]/i', '_', $seq_name);
 $seqname = sprintf($this->getOption("seqname_format"), $sqn);
 return $this->query("DROP TABLE ${seqname} RESTRICT");
 }

 
 

 function modifyQuery($query)
 {
 if ($this->options['optimize'] == 'portability') {
 
 
 if (preg_match('/^\s*DELETE\s+FROM\s+(\S+)\s*$/i', $query)) {
 $query = preg_replace('/^\s*DELETE\s+FROM\s+(\S+)\s*$/',
 'DELETE FROM \1 WHERE 1=1', $query);
 }
 }
 return $query;
 }

 
 

 function fbsqlRaiseError($errno = null)
 {
 if ($errno === null) {
 $errno = $this->errorCode(fbsql_errno($this->connection));
 }
 return $this->raiseError($errno, null, null, null,
 fbsql_error($this->connection));
 }

 
 

 function tableInfo($result, $mode = null) {
 $count = 0;
 $id = 0;
 $res = array();

 




































 
 
 if (is_string($result)) {
 $id = @fbsql_list_fields($this->dsn['database'],
 $result, $this->connection);
 if (empty($id)) {
 return $this->fbsqlRaiseError();
 }
 } else { 
 $id = $result;
 if (empty($id)) {
 return $this->fbsqlRaiseError();
 }
 }

 $count = @fbsql_num_fields($id);

 
 if (empty($mode)) {
 for ($i=0; $i<$count; $i++) {
 $res[$i]['table'] = @fbsql_field_table ($id, $i);
 $res[$i]['name'] = @fbsql_field_name ($id, $i);
 $res[$i]['type'] = @fbsql_field_type ($id, $i);
 $res[$i]['len'] = @fbsql_field_len ($id, $i);
 $res[$i]['flags'] = @fbsql_field_flags ($id, $i);
 }
 } else { 
 $res["num_fields"]= $count;

 for ($i=0; $i<$count; $i++) {
 $res[$i]['table'] = @fbsql_field_table ($id, $i);
 $res[$i]['name'] = @fbsql_field_name ($id, $i);
 $res[$i]['type'] = @fbsql_field_type ($id, $i);
 $res[$i]['len'] = @fbsql_field_len ($id, $i);
 $res[$i]['flags'] = @fbsql_field_flags ($id, $i);
 if ($mode & DB_TABLEINFO_ORDER) {
 $res['order'][$res[$i]['name']] = $i;
 }
 if ($mode & DB_TABLEINFO_ORDERTABLE) {
 $res['ordertable'][$res[$i]['table']][$res[$i]['name']] = $i;
 }
 }
 }

 
 if (is_string($result)) {
 @fbsql_free_result($id);
 }
 return $res;
 }

 
 

 




 function getSpecialQuery($type)
 {
 switch ($type) {
 case 'tables':
 $sql = 'select "table_name" from information_schema.tables';
 break;
 default:
 return null;
 }
 return $sql;
 }

 
}





?>
